﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.IO;

namespace ThiesGeneral.Media.Musik
{
    public class M3U : BindingList<M3UItem>
    {
        public M3U()
        {

        }

        public void LoadM3UFile(string fileName)
        {
            this.Clear();
            FileStream fS = new FileStream(fileName, FileMode.Open);
            StreamReader sR = new StreamReader(fS, Encoding.GetEncoding("ISO-8859-1"));
            bool newItemCreated = false;
            M3UItem newItem = new M3UItem();
            while (!sR.EndOfStream)
            {
                string contentLine = sR.ReadLine();
                if (!contentLine.Contains("#EXTM3U"))
                {
                    if (contentLine.Contains("#EXTINF"))
                    {
                        newItem = new M3UItem();
                        newItemCreated = true;
                        newItem.LengthInSec = 
                            Convert.ToInt32(
                                contentLine.Split(":".ToCharArray())[1].
                                    Split(",".ToCharArray())[0]);
                        newItem.MediaName =
                            contentLine.Split(":".ToCharArray())[1].
                                    Split(",".ToCharArray())[1];
                    }
                    else
                    {
                        if (!newItemCreated)
                        {
                          newItem = new M3UItem();
                          try
                          {
                              newItem.MediaName =
                              new FileInfo(contentLine).Name;
                          }
                          catch (Exception) { }
                        }
                        newItem.FilePath = contentLine;
                        this.Add(newItem);
                        newItemCreated = false;
                    }
                }
            }
            fS.Close();
        }

        public void SaveM3UFile(string fileName)
        {
            //#EXTM3U
            //#EXTINF:194,DÖF - Codo
            //D:\Musik\1983_top100\14 DÖF - Codo.mp3
            FileStream fS = new FileStream(fileName, FileMode.Create);
            StreamWriter sW = new StreamWriter(fS, Encoding.GetEncoding("ISO-8859-1"));
            sW.WriteLine("#EXTM3U");
            foreach (M3UItem item in this)
            {
                sW.WriteLine("#EXTINF:{0},{1}",item.LengthInSec,item.MediaName);
                sW.WriteLine(item.FilePath);
            }
            sW.Close();
        }

    }

    public class M3UItem
    {
        public string MediaName { get; set; }
        public string FilePath { get; set; }
        public int LengthInSec { get; set; }

        public M3UItem()
        {

        }

        public M3UItem(string mediaName, string filePath, int lengthInSec)
        {
            MediaName = mediaName;
            FilePath = filePath;
            LengthInSec = lengthInSec;
        }
    }
}
