﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.IO;
using ThiesGeneral.Media.Video;
using System.Windows.Forms;
using System.Windows;
using System.Threading;
using System.Windows.Automation;
using System.Diagnostics;

namespace ThiesGeneral.Media.VLC_Streaming
{
    public static class VlcStreaming
    {
        public static String PathToVLC = string.Empty;
        public static string Filename = string.Empty;
        public static string[] Filenames = new string[1];
        public static string StreamingString = string.Empty;
        public static Process VlcProcess = null;

        public static void CloseVlc()
        {
            if (VlcProcess != null)
            {
                try
                {
                    VlcProcess.Kill();
                }
                catch (Exception)
                {

                }
            }
        }
        

        public static void Open_Stream(string streamingParameter)
        {
            StreamingString = streamingParameter;
            Open_Stream();
        }

        public static void Open_Stream()
        {
            if (VlcProcess != null)
            {
                try
                {
                    VlcProcess.Kill();
                }
                catch (Exception)
                {

                }
            }
            if ((StreamingString != "") && (Filename != "") && (PathToVLC != ""))
            {
                VlcProcess = System.Diagnostics.Process.Start(PathToVLC, " \"" + Filename + "\" " + StreamingString);
            }
            else
            {
                throw new Exception("parameter missing");
            }
        }

        public static void OpenPlaylist_Stream(string streamingParameter)
        {
            StreamingString = streamingParameter;
            OpenPlaylist_Stream();
        }

        public static void OpenPlaylist_Stream()
        {
            if (VlcProcess != null)
            {
                try
                {
                    VlcProcess.Kill();
                }
                catch (Exception)
                {

                }
            }
            if ((StreamingString != "") && (Filenames[0] != "") && (PathToVLC != ""))
            {
                VideoPlaylist.GenerateASXPL(Filenames, Application.StartupPath,
                    Application.StartupPath + "\\streaminplaylist.asx");
                System.Diagnostics.Process.Start(PathToVLC, "\"" + Application.StartupPath + "\\streaminplaylist.asx" + "\" " + StreamingString);
            }
            else
            {
                throw new Exception("parameter missing");
            }
        }
       
    }
}
