﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.deusing System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace ThiesGeneral.Media.Video
{
    static public class VideoPlaylist
    {
        static public string GenerateMPCPL(List<string> filesPar, string folderPar)
        {
            return GenerateMPCPL(filesPar, folderPar, "");
        }

        static public string GenerateMPCPL(List<string> filesPar, string folderPar, string savePath)
        {
            FileStream fsStream;
            string filePath = "";
            if (savePath == "")
            {
                filePath = folderPar + @"\playlist.mpcpl";    
            }
            else
            {
                filePath = savePath;
            }
            
            string fileContent;
            StreamWriter streWriter;

            // Datei erzeugen/öffnen
            if (File.Exists(filePath) == false)
            {
                fsStream = File.Create(filePath);
                fsStream.Close();
            }

            //Header schreiben
            fileContent = "MPCPLAYLIST\r\n";

            //einzelne Videos schreiben
            int i = 0;
            foreach (string strFile in filesPar)
            {
                i++;
                fileContent = fileContent + i.ToString() + ",type,0\r\n";
                fileContent = fileContent + i.ToString() + ",filename," + strFile + "\r\n";
            }

            // in Datei schreiben
            streWriter = new StreamWriter(filePath, false, Encoding.Unicode);
            streWriter.Write(fileContent);
            streWriter.Close();
            return filePath;
        }

        static public string GenerateASXPL(IEnumerable<string> filesPar, string folderPar)
        {
            return GenerateASXPL(filesPar, folderPar, "");
        }

        static public string GenerateASXPL(IEnumerable<string> filesPar, string folderPar, string savePath)
        {

            FileStream fsStream;
            string filePath = "";
            if (savePath == "")
            {
                filePath = folderPar + @"\playlist.asx";
            }
            else
            {
                filePath = savePath;
            }
            string fileContent;
            StreamWriter streWriter;

            // Datei erzeugen/öffnen
            if (File.Exists(filePath) == false)
            {
                fsStream = File.Create(filePath);
                fsStream.Close();
            }

            //Header schreiben
            fileContent = "<ASX version = \"3.0\">\r\n";

            //einzelne Videos schreiben
            int i = 0;
            foreach (string strFile in filesPar)
            {
                i++;
                fileContent = fileContent + "<Entry><Ref href = \"" + strFile + "\"/></Entry>\r\n";
            }

            //footer schreiben
            fileContent = fileContent + "</ASX>\r\n";

            // in Datei schreiben
            streWriter = new StreamWriter(filePath, false, Encoding.UTF8);
            streWriter.Write(fileContent);
            streWriter.Close();
            return filePath;
        }
    }
}
