﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.deusing System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace ThiesGeneral.Media.Video
{
    public class XspfPlaylist
    {
        XmlDocument myDocument = new XmlDocument();
        public XspfPlaylist()
        {
            var myRoot = myDocument;
                var myPlaylist = myDocument.CreateElement("playlist");
                    var myAttr = myDocument.CreateAttribute("version");
                        myAttr.Value = "1";
                    myPlaylist.Attributes.Append(myAttr);
                    myAttr = myDocument.CreateAttribute("xmlns");
                    myAttr.Value = "http://xspf.org/ns/0/";
                    myPlaylist.Attributes.Append(myAttr);
                    myAttr = myDocument.CreateAttribute("xmlns:vnc");
                    myAttr.Value = "http://www.videolan.org/vlc/playlist/ns/0/";
                    myPlaylist.Attributes.Append(myAttr);

                    var myTitle = myDocument.CreateElement("title");
                        var myTitleNode = myDocument.CreateNode(XmlNodeType.Text, "", "");
                            myTitleNode.InnerText = "Wiedergabeliste";
                    var myTracklist = myDocument.CreateElement("trackList");
                        var myTrack1 = myDocument.CreateElement("track");
                            var myLocation = myDocument.CreateElement("location");
                                var myLocationNode = myDocument.CreateNode(XmlNodeType.Text, "", "");
                                myLocationNode.InnerText = "file:///G:/Serie/ALF/ALF%20Staffel%201/Alf.-.002.-.Die.Nacht%2C.in.der.die.Pizza.kam.%28vcd%29.mpg";
                            var myDuration = myDocument.CreateElement("duration");
                                var myDurationNode = myDocument.CreateNode(XmlNodeType.Text, "", "");
                                myDurationNode.InnerText = "23445";
                            var myExtension = myDocument.CreateElement("extension");
                                myAttr = myDocument.CreateAttribute("application");
                                myAttr.Value = "http://www.videolan.org/vlc/playlist/0";
                                myExtension.Attributes.Append(myAttr);

                                var myVlcId = myDocument.CreateElement("vlc:id");
                                    var myVlcIdNode = myDocument.CreateNode(XmlNodeType.Text, "", "");
                                    myVlcIdNode.InnerText = "0";
                                var myVlcOption = myDocument.CreateElement("vlc:option");
                                    var myVlcOptionNode = myDocument.CreateNode(XmlNodeType.Text, "", "");
                                    myVlcOptionNode.InnerText = "sout=#transcode{vcodec=mp2v,vb=2000,fps=30,width=640,acodec=mp3,ab=128,channels=2,samplerate=48000}:std{access=http,mux=ts,dst=0.0.0.0:8080}";
                var myExtension2 = myDocument.CreateElement("extension");
                    myAttr = myDocument.CreateAttribute("application");
                    myAttr.Value = "http://www.videolan.org/vlc/playlist/0";
                    myExtension2.Attributes.Append(myAttr);
                    var myVlcItem = myDocument.CreateElement("vlc:item");
                        myAttr = myDocument.CreateAttribute("tid");
                        myAttr.Value = "0";
                        myVlcItem.Attributes.Append(myAttr);

            myTitle.AppendChild(myTitleNode);

            myVlcOption.AppendChild(myVlcOptionNode);
            myVlcId.AppendChild(myVlcIdNode);
            myExtension.AppendChild(myVlcId);
            myExtension.AppendChild(myVlcOption);

            myDuration.AppendChild(myDurationNode);
            myLocation.AppendChild(myLocationNode);
            myTrack1.AppendChild(myLocation);
            myTrack1.AppendChild(myDuration);
            myTrack1.AppendChild(myExtension);

            myTracklist.AppendChild(myTrack1);

            myExtension2.AppendChild(myVlcItem);

            myTitle.AppendChild(myTitleNode);

            myPlaylist.AppendChild(myTitle);
            myPlaylist.AppendChild(myTracklist);
            myPlaylist.AppendChild(myExtension2);
            myRoot.AppendChild(myPlaylist);
            XmlTextWriter myWriter = new XmlTextWriter(@"C:\output.xspf", Encoding.UTF8);
            myWriter.Formatting = Formatting.Indented;
            myDocument.Save(myWriter);
            myWriter.Close();



            
        }
    }
}
