﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Excel = Microsoft.Office.Interop.Excel;
using System.Reflection;
using System.ComponentModel;

namespace ThiesGeneral.MsOffice
{
    public class MyExcelSerializer
    {
        private Excel.Application myExcelApplication;
        private Excel.Workbook myExcelWorkbook;
        private Excel.Worksheet myExcelWorkSheet;
        private int currentLineNo = 1;
        private int currentCoulmnNo = 1;

        public MyExcelSerializer()
        {
            try
            {
                // Excel Prozess initialisieren
                myExcelApplication = new Excel.Application();
                myExcelApplication.Visible = true;
                myExcelApplication.ScreenUpdating = true;

                // Excel Datei anlegen: Workbook
                var myCount = myExcelApplication.Workbooks.Count;
                myExcelWorkbook = (Excel.Workbook)(myExcelApplication.Workbooks.Add(System.Reflection.Missing.Value));
                myExcelWorkSheet = (Excel.Worksheet)myExcelWorkbook.ActiveSheet;
            }

            catch (Exception)
            {
                throw;
            }
            finally
            {
                // Excel beenden
                if (myExcelApplication != null)
                {
                    //myExcelApplication.Quit();
                }
            }
        }

        public void Seriliaze(object objectToSerialize, string FilePath)
        {
            WriteElements(objectToSerialize,true);
        }

        private void WriteElements(object objectToSerialize, bool writeHeader)
        {
            Type t = objectToSerialize.GetType();

            if (t.GetProperty("Item") != null)
            {
                System.Reflection.PropertyInfo p = t.GetProperty("Item");
                int count = -1;
                if (t.GetProperty("Count") != null &&
                    t.GetProperty("Count").PropertyType == typeof(System.Int32))
                {
                    count = (int)t.GetProperty("Count").GetValue(objectToSerialize, null);
                }
                if (count > 0)
                {
                    object[] index = new object[count];
                    for (int i = 0; i < count; i++)
                    {
                        object val = p.GetValue(objectToSerialize, new object[] { i });
                        WriteElements(val,i==0);
                    }
                }
            }


            foreach (PropertyInfo item in objectToSerialize.GetType().GetProperties())
            {
                if ((item.GetIndexParameters().Length == 0) )
                {
                    if (item.GetValue(objectToSerialize, null).GetType().GetProperty("Count") != null)
                    {
                        currentLineNo++;
                        currentLineNo++;
                        currentCoulmnNo = 1;
                        WriteElements(item.GetValue(objectToSerialize, null), true);
                    }
                    else
                    {
                        if (writeHeader)
                        {
                            myExcelWorkSheet.Cells[currentLineNo, currentCoulmnNo] =
                           item.Name;
                            myExcelWorkSheet.Cells[currentLineNo, currentCoulmnNo].Font.Bold = true;
                            currentLineNo++;
                        }
                        myExcelWorkSheet.Cells[currentLineNo, currentCoulmnNo] =
                            item.GetValue(objectToSerialize, null).ToString();
                    }

                    if (writeHeader)
                    {
                        currentLineNo--;
                    }
                    currentCoulmnNo++;

                    
                }
            }
            if (writeHeader)
            {
                currentLineNo++;
            }
            currentLineNo++;
            currentCoulmnNo = 1;
        }        


    }
}
