﻿using System;
using System.Configuration;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.General
{
    public class MyUpgrade
    {
        public MyUpgrade()
        {
            if (Settings.Default.MyVersion != Application.ProductVersion)
            {
                CopyFromVersion("0.1.6.7");
                CopyFromVersion("0.1.6.6");
                CopyFromVersion("0.1.6.5");
                CopyFromVersion("0.1.6.4");
                CopyFromVersion("0.1.6.3");
                CopyFromVersion("0.1.6.2");
                CopyFromVersion("0.1.6.1");
                CopyFromVersion("0.1.6.0");
                SetFilmLastTimePlayed();
                CopyFromVersion("0.1.5.4");
                CopyFromVersion("0.1.5.3");
                CopyFromVersion("0.1.5.2");
                CopyFromVersion("0.1.5.1");
                CopyFromVersion("0.1.5.0");
                CopyFromVersion("0.1.4.7");
                CopyFromVersion("0.1.4.6");
                CopyFromVersion("0.1.4.5");
                CopyFromVersion("0.1.4.4");
                CopyFromVersion("0.1.4.3");
                CopyFromVersion("0.1.4.2");
                CopyFromVersion("0.1.4.1");
                CopyFromVersion("0.1.3.3");
                CopyFromVersion("0.1.3.2");
                CopyFromVersion("0.1.3.1");
                CopyFromVersion("0.1.2.1");
                CopyFromVersion("0.1.1.1");
                CopyFromVersion("0.1.0.1");
            }
        }

        private void SetFilmLastTimePlayed()
        {
            if (File.Exists(Application.LocalUserAppDataPath + @"\appdata.xml"))
            {
                Data.Load();
                if (Data.DataFilms != null)
                {
                    foreach (Film item in Data.DataFilms)
                    {
                        if (item.LastTimePlayed == null)
                        {
                            item.LastTimePlayed = DateTime.MinValue;
                        }
                    }
                }
            }
        }

        private void CopyFromVersion(string versionNo)
        {
            string localUserAppDataPath = Application.LocalUserAppDataPath; //appdata.xml            
            string localUserAppDataPathOld = localUserAppDataPath.Replace(Application.ProductVersion, versionNo);
            //Settings.Default.MyVersion = "0.0.0.0";
            //Settings.Default.Save();

            // copy config files from old to new directory 
            if (Directory.Exists(localUserAppDataPathOld))
            {
                try
                {
                    foreach (string file in Directory.GetFiles(localUserAppDataPathOld))
                    {
                        File.Copy(file, localUserAppDataPath + "\\" + new FileInfo(file).Name, true);
                    }
                    //Directory.Delete(localUserAppDataPathOld, true);
                    Settings.Default.Upgrade();   
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message,"Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                }
                           
            }
            Settings.Default.MyVersion = Application.ProductVersion;
            Settings.Default.Save();
        }
    }
}
