﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace ThiesMediaProject.General
{
    public class SeriesEpisodeList : BindingList<SeriesEpisode>
    {
        bool IsSorted = false;
        ListSortDirection LastSortDirection = ListSortDirection.Ascending;

        public SeriesEpisodeList()
        {

        }

        protected override bool SupportsSortingCore
        {
            get
            {
                return true;
            }
        }

        public void Sort(PropertyDescriptor prop, ListSortDirection direction)
        {
            ApplySortCore(prop, direction);
        }

        protected override void ApplySortCore(PropertyDescriptor prop, ListSortDirection direction)
        {
            LastSortDirection = direction; 
            foreach (SeriesEpisode episode in this)
            {
                episode.SortingProperty = prop.GetValue(episode);
            }
            IEnumerable<SeriesEpisode> query;

            if (direction == ListSortDirection.Ascending)
            {
                query = this.OrderBy(episode => episode.SortingProperty);
            }
            else
            {
                query = this.OrderByDescending(episode => episode.SortingProperty);
            }

            int i = 0;
            foreach (SeriesEpisode episode in query)
            {
                this.Items[i] = episode;
                i++;
            }
            IsSorted = true;
        }

        protected override void RemoveSortCore()
        {

        }

        protected override bool IsSortedCore
        {
            get
            {
                return IsSorted;
            }
        }

        protected override ListSortDirection SortDirectionCore
        {
            get
            {
                return LastSortDirection;
            }
        }
    }
}
