﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ThiesMediaProject.General
{
    public class SpecialPropertyChangerFunction
    {
        public enum AvailableFunctions
        {
            DeleteCharsCountFront,
            DeleteCharsCountEnd,
            DeleteTheseText,
            ReplaceText,
            AddTextFront,
            AddTextEnd,
            AddTextAtPosition,
            DeleteTextFromPositionToPosition
        }

        public AvailableFunctions TheFunction { get; set; }
        public string Text1 { get; set; }
        public string Text2 { get; set; }
        

        public string RunFunction(AvailableFunctions myFunction, string myInstring, string myText1, string myText2)
        {
            try
            {
                switch (myFunction)
                {
                    case AvailableFunctions.DeleteCharsCountFront:
                        return DeleteCharsCountFront(myInstring, Convert.ToInt16(myText1));
                    case AvailableFunctions.DeleteCharsCountEnd:
                        return DeleteCharsCountEnd(myInstring, Convert.ToInt16(myText1));
                    case AvailableFunctions.DeleteTheseText:
                        return DeleteTheseText(myInstring, myText1);
                    case AvailableFunctions.ReplaceText:
                        return ReplaceText(myInstring, myText1, myText2);
                    case AvailableFunctions.AddTextFront:
                        return AddTextFront(myInstring, myText1);
                    case AvailableFunctions.AddTextEnd:
                        return AddTextEnd(myInstring, myText1);
                    case AvailableFunctions.AddTextAtPosition:
                        return AddTextAtPosition(myInstring, Convert.ToInt16(myText1), myText2);
                    case AvailableFunctions.DeleteTextFromPositionToPosition:
                        return DeleteTextFromPositionToPosition(myInstring, 
                            Convert.ToInt16(myText1),
                            Convert.ToInt16(myText2));
                    default:
                        return myInstring;
                }
            }
            catch (Exception)
            {
                return myInstring;
            }
        }

        private string DeleteCharsCountFront(string myInString, int myCharCount)
        {
            try
            {
                return myInString.Substring(myCharCount);
            }
            catch (Exception)
            {
                return myInString;
            }
            
        }

        private string DeleteCharsCountEnd(string myInString, int myCharCount)
        {
            try
            {
                return myInString.Substring(0, myInString.Length - myCharCount);
            }
            catch (Exception)
            {
                return myInString;
            }
        }

        private string DeleteTheseText(string myInString, string myDeleteString)
        {
            try
            {
                return myInString.Replace(myDeleteString, "");
            }
            catch (Exception)
            {
                return myInString;
            }
        }

        private string ReplaceText(string myInString, string myThisText, string myWithText)
        {
            try
            {
                return myInString.Replace(myThisText, myWithText);
            }
            catch (Exception)
            {
                return myInString;
            }
        }

        private string AddTextFront(string myInString, string myThisText)
        {
            try
            {
                return myInString = myThisText + myInString;
            }
            catch (Exception)
            {
                return myInString;
            }
        }

        private string AddTextEnd(string myInString, string myThisText)
        {
            try
            {
                return myInString = myInString + myThisText;
            }
            catch (Exception)
            {
                return myInString;
            }
        }

        private string AddTextAtPosition(string myInString, int myPosition, string myThisText)
        {
            try
            {
                return myInString = myInString.Substring(0, myPosition) + myThisText + myInString.Substring(myPosition);
            }
            catch (Exception)
            {
                return myInString;
            }
        }


        private string DeleteTextFromPositionToPosition(string myInString, int myPositionFrom, int myPositionTo)
        {
            try
            {
                return myInString = myInString.Substring(0, myPositionFrom) + myInString.Substring(myPositionTo);
            }
            catch (Exception)
            {
                return myInString;
            }
        }

    }
}
