﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;
using ThiesGeneral.Media.Musik;
using ThiesMediaProject.General;
using ThiesMediaProject.SettingForms;
using ThiesMediaProject.ToolForms;
using System.IO;
using System.Threading;
using ThiesMediaProject.ToolForms.MP3Compare;

namespace ThiesMediaProject
{
    public partial class MusikForm : Form
    {
        //Audio MyAudio;
        private bool MausDown;
        MusikList MyMusiklist = new MusikList();
        MusikList musikList = new MusikList();
        MusikPlayListForm MPLF = new MusikPlayListForm();
        M3U MyM3U = new M3U();
        public int indexOfItemUnderMouseToDrag { get; set; }
        public Rectangle dragBoxFromMouseDown { get; set; }
        public Point screenOffset { get; set; }

        public MusikForm()
        {
            InitializeComponent();
            this.Size = Settings.Default.MusikFormSize;
            Translate.TranslateForm(this);
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            musikFileBindingNavigator.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            mainFormMenuStrip.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            bindingNavigatorPositionItem.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            this.Icon = Properties.Resources.tmp_icon;
        }

        //void MyAudio_Ending(object sender, EventArgs e)
        //{
        //    if ((MPLF != null) && (!MPLF.IsDisposed))
        //    {
        //        MPLF.PlayNext();
        //    }
        //}

        private void MusikForm_Load(object sender, EventArgs e)
        {
            if (Data.DataMusikList != null)
            {
                MyMusiklist = Data.DataMusikList;
                musikFileBindingSource.DataSource = MyMusiklist;
                changeBackColor();
                musikFileDataGridView.Sort(musikFileDataGridView.Columns[1], ListSortDirection.Ascending);
                musikFileDataGridView.Sort(musikFileDataGridView.Columns[0], ListSortDirection.Ascending);
                musikFileDataGridView.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.DisplayedCells);
            }
            usePlaylistCheckBox.Checked = Properties.Settings.Default.UseMusikPlayListForPlay;
            volumeTrackBar.Maximum = 100;
            volumeTrackBar.Value = axWindowsMediaPlayer1.settings.volume;

        }

        private void button1_Click(object sender, EventArgs e)
        {
        }

        private void reloadFilmsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Data.ReloadMusik(true);
            MyMusiklist = Data.DataMusikList;
            musikFileBindingSource.DataSource = MyMusiklist;
            if (Data.DataMusikList != null)
            {
                MyMusiklist = Data.DataMusikList;
                musikFileBindingSource.DataSource = MyMusiklist;
                changeBackColor();
                musikFileDataGridView.Sort(musikFileDataGridView.Columns[1], ListSortDirection.Ascending);
                musikFileDataGridView.Sort(musikFileDataGridView.Columns[0], ListSortDirection.Ascending);
                musikFileDataGridView.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.DisplayedCells);
            }
            musikFileDataGridView.Refresh();

            changeBackColor();
        }

        public void PlayFile(string fileName)
        {
            playerTimer.Enabled = true;
            //try
            //{
            //    if (MyAudio == null)
            //    {
            //        MyAudio = new Audio(fileName);
            //        MyAudio.Ending += new EventHandler(MyAudio_Ending);
            //    }
            //    if (!MyAudio.Paused)
            //    {
            //        MyAudio.Open(fileName);
            //    }
            //    MyAudio.Play();
            //    lenthLabel.Text = new DateTime(Convert.ToInt64(10000000 * MyAudio.Duration)).TimeOfDay.ToString("hh':'mm':'ss");
            //}
            //catch (Exception)
            //{
            //    MyAudio = null;
            //}
            if (axWindowsMediaPlayer1.playState != WMPLib.WMPPlayState.wmppsPaused)
            {
                axWindowsMediaPlayer1.URL = fileName;
                nowPlayingLabel.Text = "Now playing: " + 
                    axWindowsMediaPlayer1.currentMedia.getItemInfo("Artist") +
                    " - " +
                    axWindowsMediaPlayer1.currentMedia.getItemInfo("Title") +
                    " - " +
                    axWindowsMediaPlayer1.currentMedia.getItemInfo("Album");
            }
            axWindowsMediaPlayer1.Ctlcontrols.play();
            lenthLabel.Text = new DateTime(Convert.ToInt64(10000000 * axWindowsMediaPlayer1.Ctlcontrols.currentItem.duration)).TimeOfDay.ToString("hh':'mm':'ss");
            //axWindowsMediaPlayer1.launchURL
            //axWindowsMediaPlayer1.openPlayer(
        }

        private void playButton_Click(object sender, EventArgs e)
        {
            //if ((MyAudio == null) || !MyAudio.Paused)
            //{
                if (Settings.Default.UseMusikPlayListForPlay)
                {
                    if (musikFileDataGridView.CurrentRow != null)
                    {
                        if ((MPLF.Visible))
                        {
                            bool foundFile = false;
                            for (int i = 0; i < MyM3U.Count - 1; i++)
                            {
                                if (MyMusiklist[musikFileDataGridView.CurrentRow.Index].FilePath
                                    ==
                                    MyM3U[i].FilePath
                                    )
                                {
                                    foundFile = true;
                                    MPLF.SetPosition(i);
                                    MPLF.Play();
                                }
                            }
                            if (!foundFile)
                            {
                                AddToPlaylist();
                                MPLF.SetPosition(MyM3U.Count - 1);
                                MPLF.Play();
                            }
                        }
                        else
                        {
                            MyM3U = new M3U();
                            if (MPLF.Visible == false)
                            {
                                if (MPLF.IsDisposed)
                                {
                                    MPLF = new MusikPlayListForm();
                                }
                                MPLF.ParentForm = this;
                                MPLF.Show();
                                if (this.WindowState != FormWindowState.Maximized)
                                {
                                    MPLF.Location = new Point(this.Location.X + this.Width, this.Location.Y);
                                    this.Focus();
                                }
                                else
                                {
                                    MPLF.Location = new Point(this.Location.X, this.Location.Y);
                                    MPLF.Focus();
                                }
                                
                            }
                            foreach (MusikFile item in MyMusiklist)
                            {
                                M3UItem Mitem = new M3UItem();
                                Mitem.FilePath = item.FilePath;
                                Mitem.MediaName = item.Artist + "-" +
                                    item.Titel;
                                Mitem.LengthInSec = 0;
                                MyM3U.Add(Mitem);
                            }
                            MPLF.AddMusikFile(MyM3U);
                            MPLF.SetPosition(musikFileDataGridView.CurrentRow.Index);
                            MPLF.Play();
                        }
                    }
                }
                else
                {
                    PlayFile(MyMusiklist[musikFileDataGridView.CurrentRow.Index].FilePath);
                }
            //}
            //else
            //{
            //    PlayFile("");
            //}
        }

        private void MusikForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            playerTimer.Enabled = false;
            //if (MyAudio != null)
            //{
            //    MyAudio.Dispose();    
            //}
            if (!MPLF.IsDisposed)
            {
                MPLF.Dispose();
            }
        }

        private void pauseButton_Click(object sender, EventArgs e)
        {
            axWindowsMediaPlayer1.Ctlcontrols.pause();
            //if (MyAudio != null)
            //{
            //    MyAudio.Pause();
            //}
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            axWindowsMediaPlayer1.Ctlcontrols.stop();
            lenthLabel.Text = new DateTime(Convert.ToInt64(10000000 * 0)).TimeOfDay.ToString("hh':'mm':'ss");
            positionLabel.Text = new DateTime(Convert.ToInt64(10000000 * 0)).TimeOfDay.ToString("hh':'mm':'ss");
            playPositionTrackBar.Maximum = Convert.ToInt32(0);
            playPositionTrackBar.Value = Convert.ToInt32(0);
            //if (MyAudio != null)
            //{
            //    MyAudio.Stop();
            //    MyAudio = null; 
            //}
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void playerTimer_Tick(object sender, EventArgs e)
        {
            if (axWindowsMediaPlayer1.playState == WMPLib.WMPPlayState.wmppsPlaying)
            {
                lenthLabel.Text = new DateTime(Convert.ToInt64(10000000 * axWindowsMediaPlayer1.Ctlcontrols.currentItem.duration)).TimeOfDay.ToString("hh':'mm':'ss");
                positionLabel.Text = new DateTime(Convert.ToInt64(10000000 * axWindowsMediaPlayer1.Ctlcontrols.currentPosition)).TimeOfDay.ToString("hh':'mm':'ss");
                if (!MausDown)
                {
                    playPositionTrackBar.Maximum = Convert.ToInt32(axWindowsMediaPlayer1.Ctlcontrols.currentItem.duration);
                    if (Convert.ToInt32(axWindowsMediaPlayer1.Ctlcontrols.currentPosition) <= playPositionTrackBar.Maximum)
                    {
                        playPositionTrackBar.Value = Convert.ToInt32(axWindowsMediaPlayer1.Ctlcontrols.currentPosition);    
                    }
                }
            }
            
            //if ((MyAudio != null) && (MyAudio.Playing))
            //{
            //    positionLabel.Text = new DateTime(Convert.ToInt64(10000000 * MyAudio.CurrentPosition)).TimeOfDay.ToString("hh':'mm':'ss");
            //    if (!MausDown)
            //    {
            //        playPositionTrackBar.Maximum = Convert.ToInt32(MyAudio.Duration);
            //        playPositionTrackBar.Value = Convert.ToInt32(MyAudio.CurrentPosition);    
            //    }
                
            //}
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
           
        }

        private void playPositionTrackBar_ValueChanged(object sender, EventArgs e)
        {

        }

        private void playPositionTrackBar_MouseEnter(object sender, EventArgs e)
        {
            
        }

        private void playPositionTrackBar_MouseDown(object sender, MouseEventArgs e)
        {
            MausDown = true;
        }

        private void playPositionTrackBar_MouseUp(object sender, MouseEventArgs e)
        {
            axWindowsMediaPlayer1.Ctlcontrols.currentPosition = Convert.ToDouble(playPositionTrackBar.Value);
            MausDown = false;
            //if ((MyAudio != null) && (MyAudio.Playing))
            //{
            //    MyAudio.CurrentPosition = Convert.ToDouble(playPositionTrackBar.Value);
            //}
            //MausDown = false;
        }

        private void searchTextBox_TextChanged(object sender, EventArgs e)
        {
            foreach (MusikFile musikfile in MyMusiklist)
            {
                foreach (var property in musikfile.GetType().GetProperties())
                {
                    if (property.GetValue(musikfile, null).ToString().ToUpper().Contains(searchTextBox.Text.ToUpper()))
                    {
                        musikFileDataGridView.CurrentCell =
                            musikFileDataGridView.Rows[MyMusiklist.IndexOf(musikfile)].Cells[0];
                        return;
                    }
                }
            }
        }

        private void pathSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if ((new MusikPathsForm().ShowDialog()) == System.Windows.Forms.DialogResult.OK)
            {
                Data.ReloadMusik(true);
                MyMusiklist = Data.DataMusikList;
                musikFileBindingSource.DataSource = MyMusiklist;
                musikFileDataGridView.Refresh();
                changeBackColor();
            }
        }

        private void filterButton_Click(object sender, EventArgs e)
        {
            Filter();
        }

        private void Filter()
        {
            var result = new MusikList();
            foreach (MusikFile musikFile in Data.DataMusikList)
            {
                foreach (var property in musikFile.GetType().GetProperties())
                {
                    if (property.GetValue(musikFile, null).ToString().ToUpper().Contains(filterTextbox.Text.ToUpper()))
                    {
                        result.Add(musikFile);
                        break;
                    }
                }
            }
            MyMusiklist = result;
            musikFileBindingSource.DataSource = MyMusiklist;
            musikFileDataGridView.Refresh();
            changeBackColor();
            musikFileDataGridView.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.DisplayedCells);
        }

        private void musikFileDataGridView_ColumnHeaderMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (musikFileDataGridView.SortedColumn == musikFileDataGridView.Columns[e.ColumnIndex])
            {
                if (musikFileDataGridView.SortOrder == SortOrder.Ascending)
                {
                    musikFileDataGridView.Sort(musikFileDataGridView.Columns[e.ColumnIndex], ListSortDirection.Ascending);
                }
                else
                {
                    musikFileDataGridView.Sort(musikFileDataGridView.Columns[e.ColumnIndex], ListSortDirection.Descending);
                }
            }
            else
                musikFileDataGridView.Sort(musikFileDataGridView.Columns[e.ColumnIndex], ListSortDirection.Ascending);
            musikFileBindingSource.DataSource = MyMusiklist;
            musikFileDataGridView.Refresh();
            changeBackColor();
            musikFileDataGridView.CurrentCell = musikFileDataGridView.Rows[0].Cells[0];
            musikFileDataGridView.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.DisplayedCells);
        }

        private void openDirectoryButtton_Click(object sender, EventArgs e)
        {
            if (musikFileDataGridView.CurrentRow != null)
            {
                MyMusiklist[musikFileDataGridView.CurrentRow.Index].OpenMusikFolder();
            }
        }

        private void Next()
        {
            if (musikFileDataGridView.CurrentRow != null)
            {
                for (int i = musikFileDataGridView.CurrentRow.Index + 1; i < MyMusiklist.Count; i++)
                {
                    foreach (var property in MyMusiklist[i].GetType().GetProperties())
                    {
                        if (property.GetValue(MyMusiklist[i], null).ToString().ToUpper().Contains(searchTextBox.Text.ToUpper()))
                        {
                            musikFileDataGridView.CurrentCell =
                                musikFileDataGridView.Rows[i].Cells[0];
                            return;
                        }
                    }
                }
            }
        }

        private void searchTextBox_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                Next();
            }
        }

        private void nextButton_Click(object sender, EventArgs e)
        {
            Next();
        }

        private void filterTextbox_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                Filter();
            }
        }

        private void musikFileDataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            MyMusiklist[musikFileDataGridView.CurrentRow.Index] = (MusikFile)
                musikFileBindingSource[musikFileDataGridView.CurrentRow.Index];
            MyMusiklist[musikFileDataGridView.CurrentRow.Index].WriteToFile();
            Data.Save();
        }

        private void MusikForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            Settings.Default.MusikFormSize = this.Size;
            Settings.Default.Save();
        }

        private void musikFileBindingNavigator_RefreshItems(object sender, EventArgs e)
        {

        }

        private void musikFileDataGridView_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void propertychangerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (musikFileDataGridView.CurrentCell != null)
            {
                if (musikFileDataGridView.SelectedCells.Count == 0)
                {
                    musikFileDataGridView.CurrentCell.Selected = true;
                }
                new PropertyChangerForm(musikFileDataGridView.SelectedCells).ShowDialog();
                foreach (DataGridViewCell cell in musikFileDataGridView.SelectedCells)
                {
                    MyMusiklist[cell.RowIndex].WriteToFile();
                }
                Data.Save();
            }
        }

        private void SelectRowsFromCells()
        {
            if (musikFileDataGridView.SelectedCells != null)
            {
                foreach (DataGridViewCell item in musikFileDataGridView.SelectedCells)
                {
                    item.OwningRow.Selected = true;
                }
            }
        }

        private void tagHelperToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SelectRowsFromCells();
            foreach (DataGridViewRow item in musikFileDataGridView.SelectedRows)
            {
                MusikTaggerHelpForm mthf = new MusikTaggerHelpForm(
                    MyMusiklist[item.Index]);
                mthf.ShowDialog();
            }
            Data.Save();
            musikFileDataGridView.Refresh();
            changeBackColor();
        }

        private void specialPropertychangerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            BindingList<SpecialPropertyChanger> myCells = new BindingList<SpecialPropertyChanger>();
            foreach (DataGridViewCell item in musikFileDataGridView.SelectedCells)
            {
                var myCell = new SpecialPropertyChanger();
                myCell.ValueBeforeChange = item.Value.ToString();
                myCells.Add(myCell);
            }
            var mySPCF = new SpecialPropertyChangerForm();
            mySPCF.MProperties = myCells;
            mySPCF.ShowDialog();

            int i = 0;
            StatusForm sF = new StatusForm("Save to File");
            sF.MaxValue = myCells.Count;
            sF.Show();
            foreach (SpecialPropertyChanger item in myCells)
            {
                sF.Value++;
                musikFileDataGridView.SelectedCells[i].Value = item.ValueAfterChange;
                MyMusiklist[musikFileDataGridView.SelectedCells[i].RowIndex].WriteToFile();
                i++;
            }
            sF.Close();
            Data.Save();
        }

        private void endToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        
        private void AddButton_Click(object sender, EventArgs e)
        {
            AddToPlaylist();
        }



        private void AddToPlaylist()
        {
            
            if (musikFileDataGridView.CurrentRow != null)
            {
                SelectRowsFromCells();
                foreach (DataGridViewRow item in musikFileDataGridView.SelectedRows)
	            {
                    AddToPlaylist(MyMusiklist[item.Index]);
	            }
            }
        }

        private void AddToPlaylist(MusikFile musikFile)
        {
            if (MPLF.Visible == false)
            {
                if (MPLF.IsDisposed)
                {
                    MPLF = new MusikPlayListForm();
                }
                MPLF.ParentForm = this;
                MPLF.Show();
                if (this.WindowState != FormWindowState.Maximized)
                {
                    MPLF.Location = new Point(this.Location.X + this.Width, this.Location.Y);
                    this.Focus();
                }
                else
                {
                    MPLF.Location = new Point(this.Location.X, this.Location.Y);
                    MPLF.Focus();
                }
            }
            M3UItem item = new M3UItem();
            item.FilePath = musikFile.FilePath;
            item.MediaName = musikFile.Artist + "-" +
                musikFile.Titel;
            item.LengthInSec = 0;
            MyM3U.Add(item);
            MPLF.AddMusikFile(MyM3U);
        }

        private void addToPlaylistToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AddToPlaylist();
        }

        private void usePlaylistCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.UseMusikPlayListForPlay = usePlaylistCheckBox.Checked;
            Properties.Settings.Default.Save();
        }

        internal void SearchForFile(string p)
        {
            if (musikFileDataGridView.CurrentRow != null)
            {
                foreach (MusikFile item in MyMusiklist)
                {
                    if (item.FilePath == p)
                    {
                        musikFileDataGridView.CurrentCell =
                            musikFileDataGridView.Rows[MyMusiklist.IndexOf(item)].
                                Cells[musikFileDataGridView.CurrentCell.ColumnIndex];
                        return;
                    }
                }
            }
        }

        private void loadPlaylistm3uToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (loadPlayListOpenFileDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                MyM3U.LoadM3UFile(loadPlayListOpenFileDialog.FileName);
                if (MPLF.IsDisposed)
                {
                    MPLF = new MusikPlayListForm();
                }
                MPLF.AddMusikFile(MyM3U);
                MPLF.ParentForm = this;
                
                MPLF.Show();
            }
        }

        private void generalSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            var gS = new GeneralSettingsForm();
            gS.ShowDialog();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            musikFileBindingNavigator.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            mainFormMenuStrip.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            bindingNavigatorPositionItem.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
        }

        private void numerateCellsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int i = musikFileDataGridView.SelectedCells.Count;
            foreach (DataGridViewCell item in musikFileDataGridView.SelectedCells)
            {
                item.Value = i;
                i--;
                MyMusiklist[item.RowIndex].WriteToFile();
            }
            Data.Save();
        }

        bool prevState = false;
        private void axWindowsMediaPlayer1_PlayStateChange(object sender, AxWMPLib._WMPOCXEvents_PlayStateChangeEvent e)
        {
            if (e.newState == 8)
            {
                prevState = true;
            }
            if ((e.newState == 9) && prevState)
            {
                if ((MPLF != null) && (!MPLF.IsDisposed))
                {
                    prevState = false;
                    MPLF.PlayNext();
                }
                prevState = false;
            }
        }

        private void volumeTrackBar_Scroll(object sender, EventArgs e)
        {
            axWindowsMediaPlayer1.settings.volume = volumeTrackBar.Value;
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            new FilmForm().Show();
            this.Close();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            new SeriesForm().Show();
            this.Close();
        }

        private void musikFileDataGridView_MouseDown(object sender, MouseEventArgs e)
        {
            if ((musikFileDataGridView.CurrentRow != null) && dragActivatedCheckBox.Checked)
            {
                // Get the index of the item the mouse is below.
                indexOfItemUnderMouseToDrag = musikFileDataGridView.CurrentRow.Index;

                if (indexOfItemUnderMouseToDrag != ListBox.NoMatches)
                {

                    // Remember the point where the mouse down occurred. The DragSize indicates
                    // the size that the mouse can move before a drag event should be started.                
                    Size dragSize = SystemInformation.DragSize;

                    // Create a rectangle using the DragSize, with the mouse position being
                    // at the center of the rectangle.
                    dragBoxFromMouseDown = new Rectangle(new Point(e.X - (dragSize.Width / 2),
                                                                   e.Y - (dragSize.Height / 2)), dragSize);
                }
                else
                    // Reset the rectangle if the mouse is not over an item in the ListBox.
                    dragBoxFromMouseDown = Rectangle.Empty;
            }
        }

        private void musikFileDataGridView_MouseUp(object sender, MouseEventArgs e)
        {
            // Reset the drag rectangle when the mouse button is raised.
            dragBoxFromMouseDown = Rectangle.Empty;
        }

        private void musikFileDataGridView_MouseMove(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {

                // If the mouse moves outside the rectangle, start the drag.
                if (dragBoxFromMouseDown != Rectangle.Empty &&
                    !dragBoxFromMouseDown.Contains(e.X, e.Y))
                {
                    // The screenOffset is used to account for any desktop bands 
                    // that may be at the top or left side of the screen when 
                    // determining when to cancel the drag drop operation.
                    screenOffset = SystemInformation.WorkingArea.Location;

                    // Proceed with the drag-and-drop, passing in the list item.                    
                    SelectRowsFromCells();
                    List<string> mF = new List<string>();
                    foreach (DataGridViewRow item in musikFileDataGridView.SelectedRows)
                    {
                        mF.Add(
                            MyMusiklist[
                                item.Index].FilePath);
                    }
                    string[] mf = mF.ToArray();
                    DragDropEffects dropEffect = musikFileDataGridView.DoDragDrop(
                        new DataObject(DataFormats.FileDrop, mf),
                        DragDropEffects.All | DragDropEffects.Link);

                }
            }
        }

        private void musikFileDataGridView_DataError(object sender, DataGridViewDataErrorEventArgs e)
        {

        }

        private void mP3CompareToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new Mp3CompareForm(this).Show();
        }

        private void playToolStripMenuItem_Click(object sender, EventArgs e)
        {
            playButton_Click(sender, e);
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void musikFileDataGridView_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            playButton_Click(sender, new EventArgs());
        }

        private void mainFormMenuStrip_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void changeBackColor()
        {
            bool changeColor = false;
            foreach (DataGridViewRow item in musikFileDataGridView.Rows)
            {
                if (changeColor)
                {
                    item.DefaultCellStyle.BackColor = Color.AntiqueWhite;
                    changeColor = false;
                }
                else
                {
                    changeColor = true;
                }

            }
        }
    }
}
