﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Text;
using ThiesMediaProject.General;
using ThiesGeneral.MyProcess;
using ThiesMediaProject.Properties;
using ThiesGeneral.Media.VLC_Streaming;

namespace ThiesMediaProject
{
    public static class Program
    {        
        /// <summary>
        /// Der Haupteinstiegspunkt für die Anwendung.
        /// </summary>        

        static Timer MyTimer = new Timer();

        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();            
            Application.SetCompatibleTextRenderingDefault(false);            
            var upgrade = new MyUpgrade();

            if (Settings.Default.FormFontSize == "")
            {
                Settings.Default.FormFontSize = "8";
            }

            MyTimer.Interval = Convert.ToInt32(Settings.Default.DurationProof);
            MyTimer.Tick += new EventHandler(MyTimer_Tick);
            MyTimer.Enabled = true;

            if (!Settings.Default.MainInfoShown)
            {
                new MainInfoForm().ShowDialog();
            }


            MainForm mF = new MainForm();
            if (ProcessChecker.IsOnlyProcess(mF.Text))
            {
                Data.InitData();
                if (Settings.Default.WebServer)
                {
                    TMPWebserver.StartWebSever();
                }
                Application.ApplicationExit += new EventHandler(Application_ApplicationExit);
                Application.Run(mF);
            }
        }

        static void MyTimer_Tick(object sender, EventArgs e)
        {
            MyTimer.Enabled = false;
            if (Settings.Default.ProofFilmFoldersInBackground)
            {
                Films DataFilms = new Films(Settings.Default.Paths, false);
                Data.DataFilms = DataFilms;
            }

            if (Settings.Default.ProofMusikFoldersInBackground)
            {
                MusikList DataMusik = new MusikList(Settings.Default.MusikPaths,false);
                Data.DataMusikList = DataMusik;
            }

            if (Settings.Default.ProofSeriesFoldersInBackground)
            {
                SeriesList DataFilms = new SeriesList(Settings.Default.SeriesPaths,false);
                Data.DataSeriesList = DataFilms;
            }
            Data.Save();
            MyTimer.Enabled = true;

        }

        static void Application_ApplicationExit(object sender, EventArgs e)
        {
            VlcStreaming.CloseVlc();
            TMPWebserver.StopWebSever();
        }
        
    }
}
