﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;
using System.Collections.Specialized;
using ThiesMediaProject.General;

namespace ThiesMediaProject.SettingForms
{
    public partial class DeletedFilmsForm : Form
    {

        public DeletedFilmsForm()
        {
            InitializeComponent();
        }

        private void showButton_Click(object sender, EventArgs e)
        {
            if (DeletedFilmsListBox.SelectedItem != null)
            {
                Film myFilm = new Film(DeletedFilmsListBox.SelectedItem.ToString(), Data.DataFilms.GetNewFilmId());                
                DeletedFilmsListBox.Items.Remove(
                    DeletedFilmsListBox.SelectedItem);
            }
        }

        private void FilmColumnsForm_Load(object sender, EventArgs e)
        {
            if (Settings.Default.DeletedMovies != null)
            {
                foreach (string item in Settings.Default.DeletedMovies)
                {
                    DeletedFilmsListBox.Items.Add(item);
                }    
            }
        }

        private void oKButton_Click(object sender, EventArgs e)
        {
            Settings.Default.DeletedMovies = new StringCollection();
            foreach (string item in DeletedFilmsListBox.Items)
            {
                Settings.Default.DeletedMovies.Add(item);
            }
            Settings.Default.Save();
            this.Close();
        }
    }
}
