﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;
using System.Collections.Specialized;

namespace ThiesMediaProject.SettingForms
{
    public partial class FilmColumnsForm : Form
    {
        public FilmColumnsForm()
        {
            InitializeComponent();
        }

        private void showButton_Click(object sender, EventArgs e)
        {
            if (SeriesColumnsDontShowListBox.SelectedItem != null)
            {
                SeriesColumnsDontShowListBox.Items.Remove(
                    SeriesColumnsDontShowListBox.SelectedItem);
            }
        }

        private void FilmColumnsForm_Load(object sender, EventArgs e)
        {
            if (Settings.Default.FilmsColumnsNotToShow != null)
            {
                foreach (string item in Settings.Default.FilmsColumnsNotToShow)
                {
                    SeriesColumnsDontShowListBox.Items.Add(item);
                }    
            }
        }

        private void oKButton_Click(object sender, EventArgs e)
        {
            Settings.Default.FilmsColumnsNotToShow = new StringCollection();
            foreach (string item in SeriesColumnsDontShowListBox.Items)
            {
                Settings.Default.FilmsColumnsNotToShow.Add(item);
            }
            Settings.Default.Save();
            this.Close();
        }
    }
}
