﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.SettingForms
{
    public partial class GeneralSettingsForm : Form
    {
        public GeneralSettingsForm()
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
        }

        private void GeneralSettings2Form_Load(object sender, EventArgs e)
        {
            LoadSettingsFromDefault();
        }

        private void LoadSettingsFromDefault()
        {
            Settings.Default.Reload();
            formFontSizeTextBox.Text = Settings.Default.FormFontSize;
            proofFilmFoldersInBackgroundCheckBox.Checked = Settings.Default.ProofFilmFoldersInBackground;
            proofMusikFoldersInBackgroundCheckBox.Checked = Settings.Default.ProofMusikFoldersInBackground;
            proofSeriesFoldersInBackgroundCheckBox.Checked = Settings.Default.ProofSeriesFoldersInBackground;
            DurationProofTextBox.Text = Settings.Default.DurationProof.ToString();
            webServerCheckBox.Checked = Settings.Default.WebServer;
            webServerPortTextbox.Text = Settings.Default.WebServerPort.ToString();
            vlcPathTextBox.Text = Settings.Default.VlcPath;
            vlcStreamingParameterTextBox.Text = Settings.Default.VlcStreamingParameter;
            daemonToolsTextBox.Text = Settings.Default.DaemonToolsPath;
        }

        private void SaveSettingsToDefault()
        {
            Settings.Default.FormFontSize = formFontSizeTextBox.Text;
            Settings.Default.ProofFilmFoldersInBackground = proofFilmFoldersInBackgroundCheckBox.Checked;
            Settings.Default.ProofMusikFoldersInBackground = proofMusikFoldersInBackgroundCheckBox.Checked;
            Settings.Default.ProofSeriesFoldersInBackground = proofSeriesFoldersInBackgroundCheckBox.Checked;
            Settings.Default.DurationProof = Convert.ToInt32(DurationProofTextBox.Text);
            Settings.Default.WebServer = webServerCheckBox.Checked;
            Settings.Default.WebServerPort = Convert.ToInt32(webServerPortTextbox.Text);
            Settings.Default.VlcPath = vlcPathTextBox.Text;
            Settings.Default.VlcStreamingParameter = vlcStreamingParameterTextBox.Text;
            Settings.Default.DaemonToolsPath = daemonToolsTextBox.Text;
            Settings.Default.Save();
        }

        private void GeneralSettings2Form_FormClosed(object sender, FormClosedEventArgs e)
        {
            
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {

        }

        private void oKButton_Click(object sender, EventArgs e)
        {
            SaveSettingsToDefault();
            this.Close();
        }

        private void proofMusikFoldersInBackgroundCheckBox_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void vlcPathButton_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = vlcPathTextBox.Text;
            openFileDialog1.Filter = "Vlc.exe|vlc.exe";
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                vlcPathTextBox.Text = openFileDialog1.FileName;
            }
        }

        private void webServerCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (webServerCheckBox.Checked && !TMPWebserver.IsStarted)
            {
                TMPWebserver.StartWebSever();
            }
            else
            {
                if (!webServerCheckBox.Checked)
                {
                    TMPWebserver.StopWebSever();
                }
            }
        }

        private void searchForDaemonToolsButton_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "DTLite.exe|DTLite.exe";
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                daemonToolsTextBox.Text = openFileDialog1.FileName;
            }
        }

        private void vlcPathButton_Click_1(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "vlc.exe|vlc.exe";
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                vlcPathTextBox.Text = openFileDialog1.FileName;
            }
        }


    }
}
