﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.SettingForms
{
    public partial class PathsForm : Form
    {
        public PathsForm()
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
        }

        private void FormSpeicherorte_Load(object sender, EventArgs e)
        {
            if (Settings.Default.Paths != null)
            {
                foreach (string strFolder in Settings.Default.Paths)
                {
                    listBoxFolders.Items.Add(strFolder);
                }
            }
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            folderBrowserDialogFilme.Reset();
            folderBrowserDialogFilme.ShowDialog();
            if (folderBrowserDialogFilme.SelectedPath != "")
            {
                listBoxFolders.Items.Add(folderBrowserDialogFilme.SelectedPath);
            }
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            if (listBoxFolders.SelectedIndex >= 0)
            {
                listBoxFolders.Items.RemoveAt(listBoxFolders.SelectedIndex);
            }
        }

        private void FormSpeicherorte_FormClosed(object sender, FormClosedEventArgs e)
        {            
            System.Collections.Specialized.StringCollection strFolders;
            strFolders = new System.Collections.Specialized.StringCollection();
            if (listBoxFolders.Items.Count > 0)
            {
                for (int i = 0; i < listBoxFolders.Items.Count; i++)
                {
                    listBoxFolders.SelectedIndex = i;
                    strFolders.Add(listBoxFolders.SelectedItem.ToString());
                }
                Settings.Default.Paths = strFolders;
                Settings.Default.Save();
            }
         
        }

        private void listBoxFolders_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            listBoxFolders.Items.Add(@"H:\Filme");
            listBoxFolders.Items.Add(@"L:\Filme 2");
            listBoxFolders.Items.Add(@"J:\Filme4");
            listBoxFolders.Items.Add(@"E:\Filme5");
            listBoxFolders.Items.Add(@"M:\Filme3");
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
