﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.SettingForms
{
    public partial class SeriesPathForm : Form
    {
        public SeriesPathForm()
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
        }

        private void SeiesPathForm_Load(object sender, EventArgs e)
        {
            if (Settings.Default.SeriesPaths != null)
            {
                foreach (string strFolder in Settings.Default.SeriesPaths)
                {
                    listBoxFolders.Items.Add(strFolder);
                }    
            }
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.Reset();
            folderBrowserDialog1.ShowDialog();
            if (folderBrowserDialog1.SelectedPath != "")
            {
                listBoxFolders.Items.Add(folderBrowserDialog1.SelectedPath);
            }
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            if (listBoxFolders.SelectedIndex >= 0)
            {
                listBoxFolders.Items.RemoveAt(listBoxFolders.SelectedIndex);
            }
        }

        private void SeriesPathForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            System.Collections.Specialized.StringCollection strFolders;
            strFolders = new System.Collections.Specialized.StringCollection();
            if (listBoxFolders.Items.Count > 0)
            {
                for (int i = 0; i < listBoxFolders.Items.Count; i++)
                {
                    listBoxFolders.SelectedIndex = i;
                    strFolders.Add(listBoxFolders.SelectedItem.ToString());
                }
                Settings.Default.SeriesPaths = strFolders;
                Settings.Default.Save();
            }          
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
