﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using ThiesMediaProject.General;
using ThiesMediaProject.Properties;
using System.Threading;


namespace ThiesMediaProject.ToolForms
{
    public partial class FilmFilePropertyForm : Form
    {
        string[] strFilmOrdner;

        int intFilmeAnzahl = 0;
        string[] strFilmOrdner2;
        double[] FilmLaenge;
        string[] strFilmBreite;
        string[] strFilmHoehe;

        public FilmFilePropertyForm()
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            this.Icon = Properties.Resources.tmp_icon;
        }

       

        private void FormDateiEigenschaften_Load(object sender, EventArgs e)
        {
            SetFilms2();
            textBoxBreite.Text = strFilmBreite[0];
            textBoxHoehe.Text = strFilmHoehe[0];
            DateTime dtLaenge = new DateTime((long)FilmLaenge[0] * 10000000);
            textBoxLaenge.Text = dtLaenge.TimeOfDay.ToString();
                                    
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }        

        private void readFilm2(string strOrdnerPar, string strFilePathPar)
        {
            try
            {
                axWindowsMediaPlayer1.URL = strFilePathPar;

                axWindowsMediaPlayer1.Ctlcontrols.play();
                DateTime startingDateTime = DateTime.Now;
                while (axWindowsMediaPlayer1.playState != WMPLib.WMPPlayState.wmppsPlaying)
                {
                    Thread.Sleep(1);
                    Application.DoEvents();
                    if (DateTime.Now - startingDateTime > new TimeSpan(0,0,30))
                    {
                        throw new Exception("Can't read File: " + strFilePathPar);
                    }
                }
                axWindowsMediaPlayer1.Ctlcontrols.stop();
                FilmLaenge[intFilmeAnzahl] = axWindowsMediaPlayer1.currentMedia.duration;
                strFilmBreite[intFilmeAnzahl] = axWindowsMediaPlayer1.currentMedia.imageSourceWidth.ToString();
                strFilmHoehe[intFilmeAnzahl] = axWindowsMediaPlayer1.currentMedia.imageSourceHeight.ToString();
                strFilmOrdner2[intFilmeAnzahl] = strOrdnerPar;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message, "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }


        public void setFilms(string[] strFilmOrdnerPar)
        {
            strFilmOrdner = strFilmOrdnerPar;
        }
        private void SetFilms2()
        {
            Array.Resize(ref strFilmOrdner2, strFilmOrdner.Count());
            Array.Resize(ref FilmLaenge, strFilmOrdner.Count());
            Array.Resize(ref strFilmBreite, strFilmOrdner.Count());
            Array.Resize(ref strFilmHoehe, strFilmOrdner.Count());
            string[] fileTypes = {
            "*.mpcpl",
            "*.asx",
            "*.mpls",
            "*.mkv", 
            "*.avi",
            "*.divx",
            "*.mpg",
            "*.ogm",
            "*.mpeg",
            "*.ts",
            "*.m2ts",
            "video_ts.ifo",
            "*.nrg",
            "*.iso",
            "*.img",
            "*.wmv",
            "*.mp4"
                };

            foreach (string strOrdner in strFilmOrdner)
            {
                foreach (string strEndung in fileTypes)
                {
                    if (
                        (!strEndung.Contains("mpcpl")) &&
                        (!strEndung.Contains("asx")) &&
                        (!strEndung.Contains("nrg")) &&
                        (!strEndung.Contains("iso")) &&
                        (!strEndung.Contains("ifo")) &&
                        (!strEndung.Contains("img"))
                        )
                    {
                        if (Directory.GetFiles(strOrdner, strEndung, SearchOption.AllDirectories).Count() > 0)
                        {
                            foreach (string strFile in Directory.GetFiles(strOrdner, strEndung, SearchOption.AllDirectories))
                            {
                                //readFilm(strOrdner, strFile);
                            }
                        }
                    }
                    if (strEndung.Contains("ifo"))
                    {
                        if (Directory.GetFiles(strOrdner, "*.vob", SearchOption.AllDirectories).Count() > 0)
                        {
                            foreach (string strFile in Directory.GetFiles(strOrdner, "*.vob", SearchOption.AllDirectories))
                            {
                                readFilm2(strOrdner, strFile);
                            }
                        }
                    }
                }
                intFilmeAnzahl++;
            }
        }

        private void FormDateiEigenschaften_FormClosed(object sender, FormClosedEventArgs e)
        {
            
        }

        private void buttonUebernehmen_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < strFilmOrdner2.Count(); i++)
            {
                
                DateTime dtLaenge = new DateTime((long)FilmLaenge[i] * 10000000);
                Data.DataFilms[strFilmOrdner[i]].Length = dtLaenge.TimeOfDay.ToString();
                Data.DataFilms[strFilmOrdner[i]].Height = int.Parse(strFilmHoehe[i]);
                Data.DataFilms[strFilmOrdner[i]].Width = int.Parse(strFilmBreite[i]);
                Data.DataFilms[strFilmOrdner[i]].SaveXML();
            }
            Data.Save();
            this.Close();
        }

        private void OkButton_Click(object sender, EventArgs e)
        {

        }



       

        
    }
}
