﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThiesMediaProject.General;
using System.ComponentModel;
using System.Reflection;

namespace ThiesMediaProject.ToolForms.IMDBLoader
{
    public class IMDBLoaderFilm : Film
    {
        public LoadingStatus LoadStatus { get; set; }
        public BindingList<IMDBFilm> IMDBFilms { get; set; }
        public int Films_Found_Count { get; set; }
        public int Films_Loaded_Count { get; set; }
        public int Trys_Count { get; set; }
        public IMDBFilm FilmToApply { get; set; }
        public IMDBLoaderFilm()
        {

        }

        public IMDBLoaderFilm(Film basicFilm)
        {
            LoadStatus = LoadingStatus.None;
            Films_Found_Count = 0;
            Films_Loaded_Count = 0;
            Trys_Count = 0;
            foreach (PropertyInfo item in basicFilm.GetType().GetProperties())
            {
                if (item.CanWrite)
                {
                    item.SetValue(this,
                        item.GetValue(basicFilm, null), null);    
                }
                
            }
        }

    }



    public enum LoadingStatus
    {
        None,
        Film_Search,
        Film_Search_Complete,
        Loading_Films,
        Films_Loaded,
        Worked,
        Error
    }
}
