﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using ThiesGeneral.Web;


namespace ThiesMediaProject.ToolForms
{
    public partial class IMDBStoryLoadForm : Form
    {
        string strFilmId;
        CsFilmStory filmStory;
        public IMDBStoryLoadForm()
        {
            InitializeComponent();
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void FormIMDBStoryLoad_Load(object sender, EventArgs e)
        {
            filmStory = new CsFilmStory(strFilmId);
            label1.Text = "lade";
            timer1.Enabled = true;
        }

        public string FilmIdString
        {
            get
            {
                return (strFilmId);
            }
            set
            {
                strFilmId = value;                
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if(filmStory.FilmgelesenBoolean)
            {
                label1.Text = "";
                textBox1.Text = filmStory.FilmStoryString;
            }
        }
    }

    class CsFilmStory
    {                   
        string strQuelltext;
        bool boolGelesen = false;
        string strFilmId;
        string strStory;

        public CsFilmStory()
        {
            strFilmId = "";
        }
        public CsFilmStory(string strFilmIdPar)
        {
            strFilmId = strFilmIdPar;
            loadPageFilmSearch();
        }

        public string FilmIdString
        {
            get
            {
                return (strFilmId);
            }
            set
            {
                strFilmId = value;
                loadPageFilmSearch();
            }
        }
        
        public string FilmStoryString
        {
            get
            {
                return (strStory);
            }
            set
            {
                strStory = value;
                loadPageFilmSearch();
            }
        }

        public bool FilmgelesenBoolean
        {
            get
            {
                return boolGelesen;
            }
        }

        public void loadPageFilmSearch()
        {
            if (strFilmId != "")
            {
                Uri uriAdress = new Uri("http://www.imdb.de/title/" + strFilmId + "/plotsummary");
                WebClient wcWebclient = new WebClient();
                wcWebclient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(FilmQueryComplete);
                wcWebclient.DownloadStringAsync(uriAdress);
            }
        }

        private void FilmQueryComplete(Object sender, DownloadStringCompletedEventArgs e)
        {
            if (e != null)
            {
                if (e.Error == null)
                {
                    strQuelltext = e.Result;
                    loadFilm();
                }
            }
            boolGelesen = true;
        }

        private void loadFilm()
        {

            // Story
            string strAnfang = "<div id=\"swiki.2.1\">";
            string strEnde = "</div>";
            long lngAnfang = strQuelltext.IndexOf(strAnfang);
            long lngEnde = strQuelltext.IndexOf(strEnde, Convert.ToInt16(lngAnfang) + strAnfang.Length);
            strStory = MyHtml.TransferHtmlToString(
                    strQuelltext.Substring(Convert.ToInt16(lngAnfang) + strAnfang.Length, Convert.ToInt16(lngEnde - lngAnfang - strAnfang.Length))
                );
            if (strStory == null || strStory.Length < 20)
            {
                strAnfang = "<h5>Englische Handlungs&#xFC;bersicht</h5>";
                strEnde = "</p>";
                lngAnfang = strQuelltext.IndexOf(strAnfang);
                lngEnde = strQuelltext.IndexOf(strEnde, Convert.ToInt16(lngAnfang) + strAnfang.Length);
                if ((lngAnfang > -1) & (lngEnde > -1))
                {
                    strStory = MyHtml.TransferHtmlToString(
                            strQuelltext.Substring(Convert.ToInt16(lngAnfang) + strAnfang.Length, Convert.ToInt16(lngEnde - lngAnfang - strAnfang.Length))
                        );
                }

            }
        }
    }

}
