﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThiesMediaProject.General;
using System.IO;
using System.Windows.Forms;

namespace ThiesMediaProject.ToolForms.MP3Compare
{
    class ComparedMp3 : MusikFile
    {
        public ComparedMp3()
        {
            EqualMp3s = new EqualMp3List();
        }

        public EqualMp3List EqualMp3s { get; set; }

        public int EqualCount 
        {
            get
            {
                return EqualMp3s.Count;
            }
        }

        public void DeleteMp3(ComparedMp3List comparedMp3List)
        {
            
            int comparedMp3ListCount = comparedMp3List.Count;
            for (int a = 0; a < comparedMp3ListCount; a++)           
            {
                if (comparedMp3List[a].MusicFileId != this.MusicFileId)
                {
                    int equalsMp3sCount = comparedMp3List[a].EqualMp3s.Count;
                    for (int b = 0; b < equalsMp3sCount; b++)
                    {
                        if (comparedMp3List[a].EqualMp3s[b].MusicFileId == this.MusicFileId)
                        {
                            comparedMp3List[a].EqualMp3s.RemoveAt(b);
                            b--;
                            equalsMp3sCount--;
                        }
                    }
                    if (comparedMp3List[a].EqualCount == 0)
                    {
                        comparedMp3List.RemoveAt(a);
                        a--;
                        comparedMp3ListCount--;
                    }
                }
            }
            

            //int outerIndex2 = 0;
            //List<int> musicFilesToDelete = new List<int>();
            foreach (MusikFile musikFile in Data.DataMusikList)
            {
                if (this.MusicFileId == musikFile.MusicFileId)
                {
                    try
                    {
                        File.Delete(musikFile.FilePath);
                    }
                    catch(Exception e)
                    {
                        MessageBox.Show(e.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    Data.DataMusikList.Remove(musikFile);
                    Data.Save();
                    break;
                }
            }

            comparedMp3List.Remove(this);

            
            
        }

    }
}
