﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using ThiesMediaProject.General;
using System.Windows.Forms;

namespace ThiesMediaProject.ToolForms.MP3Compare
{
    public delegate void Mp3Worked_Event(int workedCount);

    class ComparedMp3List : BindingList<ComparedMp3>
    {
        public event Mp3Worked_Event Mp3Worked;


        public int Mp3Count 
        {
            get
            {
                return Data.DataMusikList.Count;
            }
            
        }

        public ComparedMp3List()
        {
            
        }

        public void StartCompare()
        {
            int WorkedMp3s = 0;
            foreach (MusikFile mp3 in Data.DataMusikList)
            {
                ComparedMp3 newMp3 = new ComparedMp3();
                DirectCompareArtistAndTitle(mp3, newMp3);
                Application.DoEvents();


                if (newMp3.EqualCount > 0)
                {
                    AddMp3(mp3, newMp3);
                }

                WorkedMp3s++;
                Mp3Worked(WorkedMp3s);
            }
        }

        private void AddMp3(MusikFile mp3, ComparedMp3 comparedMp3)
        {            
            foreach (System.Reflection.PropertyInfo propInfo in mp3.GetType().GetProperties())
            {
                propInfo.SetValue(comparedMp3, propInfo.GetValue(mp3, null), null);
            }
            this.Add(comparedMp3);
        }

        private bool DirectCompareArtistAndTitle(MusikFile mp3, ComparedMp3 comparedMp3)
        {
            bool equalFound = false;
            foreach (MusikFile comparingMp3 in Data.DataMusikList)
            {
                if (mp3 != comparingMp3)
                {
                    if (mp3.Artist.ToUpper() == comparingMp3.Artist.ToUpper() && mp3.Titel.ToUpper() == comparingMp3.Titel.ToUpper())
                    {
                        EqualMp3 equalMp3 = new EqualMp3(comparingMp3);
                        comparedMp3.EqualMp3s.Add(equalMp3);
                        equalFound = true;
                    }
                }
            }
            return equalFound;
        }

    }
}
