﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.General;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.ToolForms.MP3Compare
{    
    public partial class Mp3CompareForm : Form
    {
        ComparedMp3List MyComparedMp3s = new ComparedMp3List();
        new MusikForm ParentForm;

        public Mp3CompareForm(Form parentForm)
        {
            InitializeComponent();
            this.Size = Settings.Default.MP3CompareFormSize;
            ParentForm = (MusikForm)parentForm;
            MyComparedMp3s.Mp3Worked += new Mp3Worked_Event(MyComparedMp3s_Mp3Worked);
        }

        void MyComparedMp3s_Mp3Worked(int workedCount)
        {
            compareStatusProgressBar.Maximum = Data.DataMusikList.Count;
            compareStatusProgressBar.Value = workedCount;
            fondMP3Label.Text = string.Format("MP3's found: {0}", MyComparedMp3s.Count);
        }

        private void Mp3CompareForm_Load(object sender, EventArgs e)
        {

        }

        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void startCompareButton_Click(object sender, EventArgs e)
        {
            MyComparedMp3s.StartCompare();
            comparedMp3BindingSource.DataSource = MyComparedMp3s;
            comparedMp3DataGridView.Refresh();
            fondMP3Label.Text = string.Format("MP3's found: {0}", MyComparedMp3s.Count);
        }

        private void comparedMp3DataGridView_SelectionChanged(object sender, EventArgs e)
        {
            if (comparedMp3DataGridView.CurrentRow != null)
            {
                equalMp3BindingSource.DataSource =
                    MyComparedMp3s[comparedMp3DataGridView.CurrentRow.Index].EqualMp3s;
                equalMp3DataGridView.Refresh();
            }
        }

        private void playSourceButton_Click(object sender, EventArgs e)
        {
            if (comparedMp3DataGridView.CurrentRow != null)
            {
                ParentForm.PlayFile(
                        MyComparedMp3s[comparedMp3DataGridView.CurrentRow.Index].FilePath);
            }
        }

        private void playEqualButton_Click(object sender, EventArgs e)
        {
            if (comparedMp3DataGridView.CurrentRow != null)
            {
                if (equalMp3DataGridView.CurrentRow != null)
                {
                    ParentForm.PlayFile(
                            MyComparedMp3s[comparedMp3DataGridView.CurrentRow.Index].
                                EqualMp3s[equalMp3DataGridView.CurrentRow.Index].FilePath);
                }
            }
        }

        private void deleteSourceButton_Click(object sender, EventArgs e)
        {
            if (comparedMp3DataGridView.CurrentRow != null)
            {
                if (MessageBox.Show("Do you really want to delete this file?","Sure?",MessageBoxButtons.YesNo,MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    MyComparedMp3s[comparedMp3DataGridView.CurrentRow.Index].DeleteMp3(MyComparedMp3s);
                    fondMP3Label.Text = string.Format("MP3's found: {0}", MyComparedMp3s.Count);
                }                
            }
        }

        private void deleteEqualButton_Click(object sender, EventArgs e)
        {
            if (comparedMp3DataGridView.CurrentRow != null)
            {
                if (equalMp3DataGridView.CurrentRow != null)
                {
                    if (MessageBox.Show("Do you really want to delete this file?", "Sure?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                    {
                        MyComparedMp3s[comparedMp3DataGridView.CurrentRow.Index].EqualMp3s[equalMp3DataGridView.CurrentRow.Index].
                            DeleteMp3(MyComparedMp3s);
                        fondMP3Label.Text = string.Format("MP3's found: {0}", MyComparedMp3s.Count);
                    }
                }
            }
        }

        private void comparedMp3DataGridView_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            playSourceButton_Click(sender, new EventArgs());
        }

        private void equalMp3DataGridView_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            playEqualButton_Click(sender, new EventArgs());
        }

        private void tableLayoutPanel2_Paint(object sender, PaintEventArgs e)
        {

        }

        private void Mp3CompareForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            Settings.Default.MP3CompareFormSize = this.Size;
        }
    }
}
