﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.General;
using System.IO;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.ToolForms
{
    public partial class MusikTaggerHelpForm : Form
    {
        MusikList _MyMusikList = new MusikList();

        public MusikTaggerHelpForm(MusikFile myMusikFile)
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            musikFileBindingNavigator.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            bindingNavigatorPositionItem.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            this.Icon = Properties.Resources.tmp_icon;
            _MyMusikList.Add(myMusikFile);
            musikFileBindingSource.DataSource = _MyMusikList;
        }

        private void MusikTaggerHelpForm_Load(object sender, EventArgs e)
        {
            addWordByDelimiter();
        }

        private void addWordByDelimiter()
        {
            wordsFromPathListBox.Items.Clear();
            if ((delimiterTextbox.Text != "") &&
                (filePathTextBox.Text != ""))
            {
                string myText = "";
                myText = new FileInfo(filePathTextBox.Text).Name;
                myText = myText.Remove(myText.Length - 4);

                string[] delString = new string[1];
                delString[0] = delimiterTextbox.Text;
                foreach (string item in myText.Split(delString, StringSplitOptions.RemoveEmptyEntries))
                {
                    wordsFromPathListBox.Items.Add(item);
                }
            }
        }


        private void delimiterTextbox_TextChanged(object sender, EventArgs e)
        {
            addWordByDelimiter();
        }

        private void AddTextTotext(ref string myText)
        {
            if (wordsFromPathListBox.SelectedItem != null)
            {
                myText = 
                    wordsFromPathListBox.SelectedItem.ToString();
                wordsFromPathListBox.Items.Remove(
                    wordsFromPathListBox.SelectedItem);
                if (wordsFromPathListBox.Items.Count != 0)
                {
                    wordsFromPathListBox.SelectedIndex = 0;
                }
            }
        }

        private void addToAlbumButton_Click(object sender, EventArgs e)
        {
            string myText = "";
            AddTextTotext(ref myText);
            _MyMusikList[0].Album = myText;
            musikFileBindingSource.ResetBindings(false);
        }

        private void addToArtisButton_Click(object sender, EventArgs e)
        {
            string myText = "";
            AddTextTotext(ref myText);
            _MyMusikList[0].Artist = myText;
            musikFileBindingSource.ResetBindings(false);
        }

        private void addToTitelButton_Click(object sender, EventArgs e)
        {
            string myText = "";
            AddTextTotext(ref myText);
            _MyMusikList[0].Titel = myText;
            musikFileBindingSource.ResetBindings(false);
        }

        private void addToGenreButton_Click(object sender, EventArgs e)
        {
            string myText = "";
            AddTextTotext(ref myText);
            _MyMusikList[0].Genre = myText;
            musikFileBindingSource.ResetBindings(false);
        }

        private void addToTitelNoButton_Click(object sender, EventArgs e)
        {
            string myText = "";
            AddTextTotext(ref myText);
            _MyMusikList[0].TitelNo = myText;
            musikFileBindingSource.ResetBindings(false);
        }

        private void addToYearButton_Click(object sender, EventArgs e)
        {
            string myText = "";
            AddTextTotext(ref myText);
            _MyMusikList[0].Year = myText;
            musikFileBindingSource.ResetBindings(false);
        }

        private void MusikTaggerHelpForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            _MyMusikList[0].WriteToFile();
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
