﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.ToolForms
{
    public partial class PropertyChangerForm : Form
    {
        DataGridViewSelectedCellCollection _ObjectsToChange;
        public PropertyChangerForm()
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble((float)Convert.ToDouble(Settings.Default.FormFontSize)));
            this.Icon = Properties.Resources.tmp_icon;
        }

        public PropertyChangerForm(DataGridViewSelectedCellCollection objectsToChange)
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            this.Icon = Properties.Resources.tmp_icon;
            _ObjectsToChange = objectsToChange;
            propertyValueTextBox.Text = objectsToChange[0].Value.ToString();
            propertyNameLabel.Text = objectsToChange[0].OwningColumn.HeaderText;
            dataSetCountLabel.Text = "Count: " + objectsToChange.Count;
        }


        private void PropertyChangerForm_Load(object sender, EventArgs e)
        {

        }

        private void okButton_Click(object sender, EventArgs e)
        {
            if (_ObjectsToChange != null)
            {
                foreach (DataGridViewCell dGC in _ObjectsToChange)
                {
                    dGC.Value = propertyValueTextBox.Text;
                }
            }
            this.Close();
        }

       
    }
}
