﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.General;

namespace ThiesMediaProject.ToolForms
{
    public partial class SeriesStatisticForm : Form
    {
        public SeriesStatisticForm()
        {
            InitializeComponent();
        }

        private void StatisticForm_Load(object sender, EventArgs e)
        {
            long sumSize = 0;
            long sumWidth = 0;
            long sumHeight = 0;
            long seriesEpisodeCount = 0;
            TimeSpan sumLength = new TimeSpan(0);
            foreach (Series series in Data.DataSeriesList)
            {
                foreach (SeriesEpisode item in series.SeriesEpisodes)
                {
                    sumWidth += item.Width;
                    sumHeight += item.Height;
                    sumSize += item.SizeMB;
                    sumLength += new TimeSpan(
                        Convert.ToInt16(item.Length.Split(":".ToArray())[0]),
                        Convert.ToInt16(item.Length.Split(":".ToArray())[1]),
                        Convert.ToInt16(item.Length.Split(":".ToArray())[2]));
                }
                seriesEpisodeCount += series.SeriesEpisodes.Count;
            }
            averageHeightTextBox.Text = (sumHeight / seriesEpisodeCount).ToString();
            averageWidthTextBox.Text = (sumWidth / seriesEpisodeCount).ToString();
            averageLengthTextBox.Text = new TimeSpan((sumLength.Ticks / seriesEpisodeCount)).ToString();
            averageSizeTextBox.Text = (sumSize / seriesEpisodeCount).ToString() + " MB";
            episodeCountTextBox.Text = seriesEpisodeCount.ToString();
            sizeTextBox.Text = (sumSize / 1024).ToString() + " GB";
            lengthTextBox.Text = sumLength.ToString();
            seriesCountTextBox.Text = Data.DataSeriesList.Count.ToString();                        
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
