﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.General;

namespace ThiesMediaProject.ToolForms
{
    public partial class StatisticForm : Form
    {
        public StatisticForm()
        {
            InitializeComponent();
        }

        private void StatisticForm_Load(object sender, EventArgs e)
        {
            long sumSize = 0;
            long sumWidth = 0;
            long sumHeight = 0;
            TimeSpan sumLength = new TimeSpan(0);
            foreach (Film film in Data.DataFilms)
            {
                sumWidth += film.Width;
                sumHeight += film.Height;
                sumSize += film.SizeMB;
                sumLength += new TimeSpan(
                    Convert.ToInt16(film.Length.Split(":".ToArray())[0]),
                    Convert.ToInt16(film.Length.Split(":".ToArray())[1]),
                    Convert.ToInt16(film.Length.Split(":".ToArray())[2]));
            }
            averageHeightTextBox.Text = (sumHeight / Data.DataFilms.Count).ToString();
            averageWidthTextBox.Text = (sumWidth / Data.DataFilms.Count).ToString();
            averageLengthTextBox.Text = new TimeSpan((sumLength.Ticks / Data.DataFilms.Count)).ToString();
            averageSizeTextBox.Text = (sumSize / Data.DataFilms.Count).ToString() + " MB";
            filmCountTextBox.Text = Data.DataFilms.Count.ToString();
            sizeTextBox.Text = (sumSize / 1024).ToString() + " GB";
            lengthTextBox.Text = sumLength.ToString();
                        
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
