﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.ToolForms
{
    public partial class StatusForm : Form
    {
        
        public int Value 
        {
            get
            {
                return statusProgressbar.Value;
            }
            set
            {
                statusProgressbar.Value = value;
                countLabel.Text = statusProgressbar.Value.ToString() +
                    "(" + statusProgressbar.Maximum.ToString() + ")";
                Application.DoEvents();
                this.Refresh();
                //this.Update();
                this.BringToFront();
                //this.Activate();
            }
        }
        public int MaxValue 
        {
            get
            {
                return statusProgressbar.Maximum;
            }
            set
            {
                statusProgressbar.Maximum = value;
            }
        }
        public bool AllowCancel { get; set; }
        public bool Canceled { get; set; }


        public StatusForm()
        {
            InitForm("Status");
        }

        public StatusForm(string title)
        {
            InitForm(title);
        }

        private void InitForm(string title)
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            this.Icon = Properties.Resources.tmp_icon;
            this.Text = title;
            AllowCancel = false;
            Canceled = false;
        }

        private void StatusForm_Load(object sender, EventArgs e)
        {
            cancelButton.Visible = AllowCancel;
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            Canceled = true;
        }

        public void CancelProcess()
        {
            if (AllowCancel)
            {
                Canceled = true;
            }
            else
            {
                throw new Exception("Cancelation is not allowed");
            }
        }
    }
}
