﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using ThiesGeneral.FileFunctions;
using ThiesGeneral.Media.Video;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.ToolForms
{
    public partial class StreamPlayForm : Form
    {
        List<string> films;

        public string Folder { get; set; }
                                                   

        public StreamPlayForm()
        {
            InitializeComponent();
            this.Font = new Font(this.Font.FontFamily, (float)Convert.ToDouble(Settings.Default.FormFontSize));
            this.Icon = Properties.Resources.tmp_icon;
        }

        private void FormMultiPlay_Load(object sender, EventArgs e)
        {

        }

        public void AddFilms(string[] filmsPar)
        {
            films = new List<string>(filmsPar);
            listBoxFilms.Items.AddRange(filmsPar);
        }

        public string[] ReturnFilms()
        {
            return films.ToArray();
        }




        private void buttonOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }


        private void deleteButton_Click(object sender, EventArgs e)
        {
            films.RemoveAt(listBoxFilms.SelectedIndex);
            listBoxFilms.Items.Remove(listBoxFilms.SelectedItem);
        }

        private void upButton_Click(object sender, EventArgs e)
        {
            var myListbox = new ListBox();
            
            if (listBoxFilms.SelectedIndex > 0)
            {
                for (int a = 0; a < listBoxFilms.Items.Count; a++)
                {
                    if (a < listBoxFilms.Items.Count - 1)
                    {
                        if (listBoxFilms.Items[a + 1] == listBoxFilms.SelectedItem)
                        {
                            myListbox.Items.Add(listBoxFilms.SelectedItem);
                            myListbox.Items.Add(listBoxFilms.Items[a]);
                            a++;
                        }
                        else
                        {
                            myListbox.Items.Add(listBoxFilms.Items[a]);
                        }
                    }
                    else
                    {
                        myListbox.Items.Add(listBoxFilms.Items[a]);
                    }
                }
                for (int i = 0; i < listBoxFilms.Items.Count; i++)
                {
                    listBoxFilms.Items[i] = myListbox.Items[i];
                }
                listBoxFilms.SelectedIndex--;
            }
        }

        private void downButton_Click(object sender, EventArgs e)
        {
            var myListbox = new ListBox();

            if (listBoxFilms.SelectedItem != null)
            {
                for (int a = 0; a < listBoxFilms.Items.Count; a++)
                {
                    if (a < listBoxFilms.Items.Count - 1)
                    {
                        if (listBoxFilms.Items[a] == listBoxFilms.SelectedItem)
                        {
                            myListbox.Items.Add(listBoxFilms.Items[listBoxFilms.SelectedIndex+1]);
                            myListbox.Items.Add(listBoxFilms.SelectedItem);
                            a++;
                        }
                        else
                        {
                            myListbox.Items.Add(listBoxFilms.Items[a]);
                        }
                    }
                    else
                    {
                        myListbox.Items.Add(listBoxFilms.Items[a]);
                    }
                }
                for (int i = 0; i < listBoxFilms.Items.Count; i++)
                {
                    listBoxFilms.Items[i] = myListbox.Items[i];
                }
                listBoxFilms.SelectedIndex++;
            }
        }

    }
}
