﻿/// Copyright © 2010-2011 Sebastian Thies
/// This program is distributed under the terms of the GNU General Public License
/// http://www.gnu.org/licenses/#GPL
/// email: sebastian.thies@arcor.de
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThiesMediaProject.Properties;

namespace ThiesMediaProject.ToolForms
{
    public partial class WishListForm : Form
    {
        TextBox tb = new TextBox();
        int intWorkedItem;

        public WishListForm()
        {
            InitializeComponent();
        }

        private void listViewWuensche_SelectedIndexChanged(object sender, EventArgs e)
        {
           
        }

        private void buttonNeuer_Click(object sender, EventArgs e)
        {
            ListViewItem lviItem = listViewWuensche.Items.Add(" ");
            intWorkedItem = lviItem.Index;
            tb.Location = new Point(lviItem.Position.X + listViewWuensche.Location.X,
                                    lviItem.Position.Y + listViewWuensche.Location.Y);

            tb.Width = listViewWuensche.Columns[0].Width;
            tb.Height = 50;
            tb.Visible = true;
            tb.BringToFront();
            tb.Select();
            
            
            
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttonLoeschen_Click(object sender, EventArgs e)
        {
            foreach (ListViewItem lviItem in listViewWuensche.SelectedItems)
            {
                lviItem.Remove();
            }
        }

        private void textBox1_Leave(object sender, EventArgs e)
        {
            if (intWorkedItem > -1)
            {
                listViewWuensche.Items[
                    intWorkedItem].Text = tb.Text;                                
            }
            tb.Text = "";
            tb.Visible = false;
        }

        private void FormWunschliste_Load(object sender, EventArgs e)
        {
            if (Settings.Default.Wishes != null)
            {
                foreach (string strWunsch in Settings.Default.Wishes)
                {
                    listViewWuensche.Items.Add(strWunsch);
                }
            }
            this.Controls.Add(tb);
            
            tb.Visible = false;
            this.tb.Leave += new System.EventHandler(this.textBox1_Leave);
        }

        private void FormWunschliste_FormClosed(object sender, FormClosedEventArgs e)
        {
            System.Collections.Specialized.StringCollection strListe = new System.Collections.Specialized.StringCollection();
            foreach (ListViewItem lviItem in listViewWuensche.Items)
            {
                strListe.Add(lviItem.Text);
            }
            Settings.Default.Wishes = strListe;
            Settings.Default.Save();
        }

        private void listViewWuensche_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            ListViewItem lviItem = listViewWuensche.FocusedItem;
            intWorkedItem = lviItem.Index;
            tb.Location = new Point(lviItem.Position.X + listViewWuensche.Location.X,
                                    lviItem.Position.Y + listViewWuensche.Location.Y);

            tb.Width = listViewWuensche.Columns[0].Width;
            tb.Height = 50;
            tb.Text = lviItem.Text;
            tb.Visible = true;
            tb.BringToFront();
            tb.Select();
        }

        private void listViewWuensche_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.F2)
            {
                MouseEventArgs a = new MouseEventArgs(System.Windows.Forms.MouseButtons.Left ,2,0,0,0);
                listViewWuensche_MouseDoubleClick(sender, a);
            }
        }
    }
}
